/********************************************************************************************************\

	File Name:	CommonDestroyer.cpp
	Descript:	<DESCRIPTION>

\********************************************************************************************************/


#include "MissionText.h"
#include "CommonDefs.h"
#include "CommonDestroyer.h"
#include "CommonDestroyerBaseState.h"
#include "TeamInfo.h"

tClassAllocator<tCommonDestroyer> gCommonDestroyerAllocator;

void tCommonDestroyer::mSetupState()
{
	mRegisterState( new tCommonDestroyerBaseState() );
	mGotoState( typeid( tCommonDestroyerBaseState ) );
}
void tCommonDestroyer::mSetupCommState()
{}
void tCommonDestroyer::mSetupShip()
{

#ifdef FIGHTERS
#ifdef DEBUGOUT
	FILE *fp = fopen("C:\\bfest+.txt", "a");
	fprintf(fp, "Setting up: Team %d\n", (int )mGetTeam());
	fflush(fp);
#endif

	// Fighter random-generation code
	Ship aShip;
	global_sl.Find(mGetClassName(), aShip);

	// check for fighters.
	// up to 4 fighter bays
	int num_bays = 0;
	int32 count = 0;
	int32 total_num_fighters = 0;

	Ship selected_fighter;
	BaseShip fighter;
	ShipList tmpfighter_sl;

	for (int k = 0; k < 4; k++)
	{
		fighter = aShip.fighters[k].first;
		count = aShip.fighters[k].second;
		if (count)
		{
			num_bays++;
			total_num_fighters += count;
		}
	}

	tmpfighter_sl = narrowed_fighter_sl;
	std::list< eRace >	tmpraces;
	tmpraces.push_back(aShip.race);
	tmpfighter_sl.Subset(tmpraces);

	if (tmpfighter_sl.size()) {
		tmpfighter_sl.SelectRandomShip(selected_fighter);

		if (total_num_fighters)
		{
			int32 avg_fighters = total_num_fighters / num_bays;
			if (total_num_fighters % num_bays)
				avg_fighters++;

			mSetFighters(num_bays, 
				avg_fighters, selected_fighter.shipCode);

#ifdef DEBUGOUT
			fprintf(fp, "---- Destroyer, Team: %d   Fighters: %s\n", 
				(int )mGetTeam(), selected_fighter.shipCode.c_str());
			fflush(fp);
#endif
		}
	}
	fclose(fp);
#endif


	mSetShipCallbackEvents( kNotifyDamage );

	tTeamInfo*	CommonTeam = fMissionInfo->mGetTeamHandle( mGetTeam() );
	Assert( CommonTeam );
	if ( !CommonTeam )
		return;

	if ( CommonTeam->mIsTeamHumanControlled() )
		mSetShipPlayerControlled();

	mSetTargetable( kFalse );
}