/********************************************************************************************************\

	File Name:	CommonDreadnoughtBaseState.cpp
	Descript:	<DESCRIPTION>

\********************************************************************************************************/

#include "MissionText.h"
#include "CommonDefs.h"
#include "CommonDreadnoughtBaseState.h"
#include "CommonDreadnought.h"
#include "ScriptInterface.h"
#include "WorldConditions.h"


/*

	HELPER NOTE:	There are so many things that can be done here depending upon which mission you are
					coding.  So rather than list out possible bodies for each of the events below, the
					signatures have been given to save time cutting and pasting.  However, if you do need
					examples of the bodies of these functions, please feel free to refer back to ISC_5Accuse,
					which is the latest mission and the mission that contains files that most closely reflect
					this file and others in this script.

*/
void tCommonDreadnoughtBaseState::mBeginState()
{
	mSetTimedInterval( kTimerTurnsSet, kInvincibility_TID, 0.5f );
}
void tCommonDreadnoughtBaseState::mEndState()
{}

void tCommonDreadnoughtBaseState::mOnDeath( tShipInfo* ship )
{}
void tCommonDreadnoughtBaseState::mOnCapture( tShipInfo* ship )
{}
void tCommonDreadnoughtBaseState::mOnDisengaged( tShipInfo* ship )
{}
void tCommonDreadnoughtBaseState::mAtDistance( tShipInfo* ship )
{}
void tCommonDreadnoughtBaseState::mAtDestination( tShipInfo* ship )
{}
void tCommonDreadnoughtBaseState::mOnCommButtonPress( tShipInfo* ship, int32 buttonID, tShipInfo* targetShip )
{}
void tCommonDreadnoughtBaseState::mOnDamage( tShipInfo* damagedShip, tShipInfo* hostileShip, eDamageToShip damageType )
{}
void tCommonDreadnoughtBaseState::mOnDeepScan( tShipInfo* ship, iTruth deepScanOn )
{}
void tCommonDreadnoughtBaseState::mOnAlertStatusChange( tShipInfo* ship, eAlertLevels alertStatus )
{}
void tCommonDreadnoughtBaseState::mOnProbeLaunch( tShipInfo* ship )
{}
void tCommonDreadnoughtBaseState::mOnBeginOrbit( tShipInfo* ship )
{}
void tCommonDreadnoughtBaseState::mOnEndOrbit( tShipInfo* ship )
{}
void tCommonDreadnoughtBaseState::mOnBeginTractor( tShipInfo* tractorTarget, tShipInfo* tractoringShip )
{}
void tCommonDreadnoughtBaseState::mOnEndTractor( tShipInfo* tractorTarget, tShipInfo* tractoringShip )
{}
void tCommonDreadnoughtBaseState::mOnFlashingButtonPressed()
{}
void tCommonDreadnoughtBaseState::mOnTransportedItem( tShipInfo* shipTo, tShipInfo* shipFrom, eScriptTransportItems item )
{}
void tCommonDreadnoughtBaseState::mOnChangingShip( tShipInfo* ship )
{}
void tCommonDreadnoughtBaseState::mOnSpecialTransport( tShipInfo* ship )
{}

void tCommonDreadnoughtBaseState::mOnPlayerLeaving( int32 playerNumber, eTeamID TeamID )
{}
void tCommonDreadnoughtBaseState::mOnHostChanged()
{}
void tCommonDreadnoughtBaseState::mOnTimedInterval( int32 timerID )
{
	switch ( timerID )
	{
	case kInvincibility_TID:
		{
			fChildActor->mSetTargetable( kTrue );
		}
		break;
	}
}
void tCommonDreadnoughtBaseState::mOnStateChange( tActor* actor, tState* stateID, eStateEvent eventType )
{}
void tCommonDreadnoughtBaseState::mOnCommStateChange( tActor* actor, int32 state, int32 buttonID, eStateEvent eventType )
{}


